
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Time_entriesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const time_entries = await db.time_entries.create(
            {
                id: data.id || undefined,
        
        started_at: data.started_at
        ||
        null
            ,
            
        ended_at: data.ended_at
        ||
        null
            ,
            
        duration_hours: data.duration_hours
        ||
        null
            ,
            
        billable: data.billable
        ||
        false
        
            ,
            
        work_type: data.work_type
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        offline_recorded: data.offline_recorded
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await time_entries.setTenant( data.tenant || null, {
            transaction,
        });
        
        await time_entries.setUser( data.user || null, {
            transaction,
        });
        
        await time_entries.setTimesheet( data.timesheet || null, {
            transaction,
        });
        
        await time_entries.setCompany( data.company || null, {
            transaction,
        });
        
        await time_entries.setProject( data.project || null, {
            transaction,
        });
        
        await time_entries.setTask( data.task || null, {
            transaction,
        });
        
        await time_entries.setService_line( data.service_line || null, {
            transaction,
        });
        
        await time_entries.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return time_entries;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const time_entriesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                started_at: item.started_at
            ||
            null
            ,
            
                ended_at: item.ended_at
            ||
            null
            ,
            
                duration_hours: item.duration_hours
            ||
            null
            ,
            
                billable: item.billable
            ||
            false
        
            ,
            
                work_type: item.work_type
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                offline_recorded: item.offline_recorded
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const time_entries = await db.time_entries.bulkCreate(time_entriesData, { transaction });

        // For each item created, replace relation files
        

        return time_entries;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const time_entries = await db.time_entries.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.ended_at !== undefined) updatePayload.ended_at = data.ended_at;
        
        
        if (data.duration_hours !== undefined) updatePayload.duration_hours = data.duration_hours;
        
        
        if (data.billable !== undefined) updatePayload.billable = data.billable;
        
        
        if (data.work_type !== undefined) updatePayload.work_type = data.work_type;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.offline_recorded !== undefined) updatePayload.offline_recorded = data.offline_recorded;
        
        
        updatePayload.updatedById = currentUser.id;

        await time_entries.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await time_entries.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await time_entries.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.timesheet !== undefined) {
            await time_entries.setTimesheet(
              
              data.timesheet,
              
              { transaction }
            );
        }
        
        if (data.company !== undefined) {
            await time_entries.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.project !== undefined) {
            await time_entries.setProject(
              
              data.project,
              
              { transaction }
            );
        }
        
        if (data.task !== undefined) {
            await time_entries.setTask(
              
              data.task,
              
              { transaction }
            );
        }
        
        if (data.service_line !== undefined) {
            await time_entries.setService_line(
              
              data.service_line,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await time_entries.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return time_entries;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const time_entries = await db.time_entries.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        if (time_entries.length !== ids.length) {
            const error = new Error('One or more items were not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await db.sequelize.transaction(async (transaction) => {
            for (const record of time_entries) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of time_entries) {
                await record.destroy({transaction});
            }
        });


        return time_entries;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const time_entries = await db.time_entries.findByPk(id, options);

        if (!time_entries) {
            const error = new Error('Item not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await time_entries.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await time_entries.destroy({
            transaction
        });

        return time_entries;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const time_entries = await db.time_entries.findOne(
            { where },
            { transaction },
        );

        if (!time_entries) {
            return time_entries;
        }

        const output = time_entries.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await time_entries.getTenant({
            transaction
        });
        
        
        output.user = await time_entries.getUser({
            transaction
        });
        
        
        output.timesheet = await time_entries.getTimesheet({
            transaction
        });
        
        
        output.company = await time_entries.getCompany({
            transaction
        });
        
        
        output.project = await time_entries.getProject({
            transaction
        });
        
        
        output.task = await time_entries.getTask({
            transaction
        });
        
        
        output.service_line = await time_entries.getService_line({
            transaction
        });
        
        
        output.organizations = await time_entries.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.timesheets,
        as: 'timesheet',
        
        where: filter.timesheet ? {
          [Op.or]: [
            { id: { [Op.in]: filter.timesheet.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.timesheet.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.companies,
        as: 'company',
        
        where: filter.company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.company.split('|').map(term => Utils.uuid(term)) } },
            {
              legal_name: {
                [Op.or]: filter.company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.projects,
        as: 'project',
        
        where: filter.project ? {
          [Op.or]: [
            { id: { [Op.in]: filter.project.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.project.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tasks,
        as: 'task',
        
        where: filter.task ? {
          [Op.or]: [
            { id: { [Op.in]: filter.task.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.task.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.service_lines,
        as: 'service_line',
        
        where: filter.service_line ? {
          [Op.or]: [
            { id: { [Op.in]: filter.service_line.split('|').map(term => Utils.uuid(term)) } },
            {
              name_fr: {
                [Op.or]: filter.service_line.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'time_entries',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            started_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    ended_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.ended_atRange) {
                const [start, end] = filter.ended_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ended_at: {
                    ...where.ended_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ended_at: {
                    ...where.ended_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.duration_hoursRange) {
                const [start, end] = filter.duration_hoursRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    duration_hours: {
                    ...where.duration_hours,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    duration_hours: {
                    ...where.duration_hours,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.billable) {
                where = {
                    ...where,
                billable: filter.billable,
            };
            }
            
            if (filter.work_type) {
                where = {
                    ...where,
                work_type: filter.work_type,
            };
            }
            
            if (filter.offline_recorded) {
                where = {
                    ...where,
                offline_recorded: filter.offline_recorded,
            };
            }
            


      

      

      

      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.time_entries.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationsId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'time_entries',
                        'description',
                        query,
                    ),
                ],
            };
        }

        const records = await db.time_entries.findAll({
            attributes: [ 'id', 'description' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['description', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.description,
        }));
    }

    
};

